.386p
.387
.model flat, stdcall

extrn MessageBoxA:proc
extrn GlobalAlloc:proc
extrn GlobalFree:proc
extrn ExitProcess:proc

.data
szTitle        db "Garbage Generator demo", 0
szText         db "Cration du garbage russi...", 0
szTitleError   db "Erreur...", 0
szTextError    db "Cration du garbage impossible...", 0
szFileName     db "SAMPLE.EXE", 0
hFile          dd ?
lpBuffer       dd ?
liSeed         dd 1234567890d
liPrimeNumber1 dd 9999991d
liPrimeNumber2 dd 8490233d

BUFFER_SIZE equ 1000h

.code
GG_DEMO:
  push BUFFER_SIZE
  push 0
  call GlobalAlloc
  mov lpBuffer, eax
  xchg edi, eax
  xor eax, eax
  push liPrimeNumber2
  push liPrimeNumber1
  push offset liSeed
  push offset RndNumberGenerator
  push 90900102h ;unused n2: ecx, edx
  push 90900003h ;unused n1: eax, ebx
  push 90900405h ;used n2: ebp, esp
  push 90900607h ;used n1: esi, edi
  push BUFFER_SIZE
  push edi
  call GarbageGenerator
  cmp eax, GG_ERROR
  je Error
  mov eax, offset szFileName
  call fcreate
  mov hFile, eax
  mov ebx, BUFFER_SIZE
  mov ecx, lpBuffer
  call fwrite
  test eax, eax
  je Error
  mov eax, hFile
  call fclose
  push 0
  push offset szTitle
  push offset szText
  push 0
  call MessageBoxA
  jmp GG_EXIT
Error:
  push 0
  push offset szTitleError
  push offset szTextError
  push 0
  call MessageBoxA
GG_EXIT:
  push lpBuffer
  call GlobalFree
  push 0
  call ExitProcess
  include Gg.inc
  include GgHeader.inc
  include FILE_IO.INC
  include RndNumberGenerator.inc
end GG_DEMO
